#!/usr/bin/perl -w

$Perl	= shift;
@Pages = ('rguest.html', 'sampform.html');
@Gifs = ('bg.gif', 'gobotrt.gif', 'quote.gif', 'bluemarb.gif');
@Scripts = ('guestnik', 'rguest');
@Utils = ('checkstd');
@Configs = ('guestnik.cfg', 'rguest.cfg');
@Man = ('guestnik.1');
@Docs = ('guestnik.html', 'guestnik.txt');
$CGIDIR = -d "../cgi-bin"
			? "../cgi-bin"
			: '';
$HTDOCDIR = -d "../htdocs"
			? "../htdocs"
			: '';

sub dontwarn { &dontwarn + @Man + @Docs; }
sub prompt {
	local($pr) = shift || '? ';
	local($def) = shift;
	local($ans);

	print $pr;
	print "[$def] " if $def;
	chop($ans = <STDIN>);
	$ans ? $ans : $def;
}

print "\nGuestnik needs to know where your cgi-bin directory is\n";
print "so it can copy the guestnik script and configuration there.\n";

for(;;) {
$CGIDIR = -d $CGIDIR
			? $CGIDIR
			: '';
	print <<EOF unless $second_time_through++;

If you don't know the answer to this question, contact your
vendor.  Or go to your cgi-bin directory and type:

	\$ pwd

It will give the path name you should enter.

EOF
	if($CGIDIR) {
		print <<EOF ;

I ran a check on the path '$CGIDIR', and found it.

(Type quit to try again)
EOF
		$ans = &prompt("Press return to accept this as your cgi-bin directory ",
				$CGIDIR);
		last if ( !$ans || ($ans eq $CGIDIR) );
		$CGIDIR = $ans;
	}
	else {
		print "\nNo directory '$CGIDIR' was found.\n\n";
		if($second_time_through > 1) {
			$ans = &prompt("Continue? ", 'y');
			exit 1 unless $ans =~ /^\s*y/i;
		}
		$CGIDIR = &prompt("Where is your cgi-bin directory? ", $CGIDIR);
	}
}

undef $second_time_through;

print <<EOF ;

**
Guestnik needs to know where your HTML document directory is,
so it can copy the sample forms and images there.

EOF
for(;;) {
$HTDOCDIR = -d $HTDOCDIR
			? $HTDOCDIR
			: '';
	print <<EOF unless $second_time_through++;

If you don't know the answer to this question, contact your
vendor.  Or go to your HTML document directory and type:

	\$ pwd

It will give the path name you should enter.

EOF
	if($HTDOCDIR) {
		print <<EOF ;

I ran a check on the path '$HTDOCDIR', and found it.

(Type quit to try again)
EOF
		$ans = &prompt("Press return to accept this as your cgi-bin directory ",
				$HTDOCDIR);
		last if (!$ans || ($ans eq $HTDOCDIR) );
		$HTDOCDIR = $ans;
	}
	else {
		print "\nNo directory '$HTDOCDIR' was found.\n\n";
		if($second_time_through > 1) {
			$ans = &prompt("Continue? ", 'y');
			exit 1 unless $ans =~ /^\s*y/i;
		}
		$HTDOCDIR = &prompt("Where is your HTML document directory? ", $HTDOCDIR);
	}
}

$ans = &prompt("\nReady to copy the files.  OK? ", 'y');
exit unless $ans =~ /^\s*y/i;

foreach $file (@Scripts) {
	if (-f "$CGIDIR/$file") {
		$ans = &prompt("\n$CGIDIR/$file exists. Overwrite? ", 'y');
		next unless $ans =~ /^\s*y/i;
	}
	print "Copying $file to $CGIDIR/$file....";
	open(NEWSCRIPT, ">$CGIDIR/$file")
		|| die "\nCouldn't create $CGIDIR/$file: $!\n";
	open(SCRIPT, "$file")
		|| die "\nCouldn't read $file: $!\n";
	print NEWSCRIPT "#!$Perl\n";
	print NEWSCRIPT while <SCRIPT>;
	close NEWSCRIPT;
	close SCRIPT;
	chmod 0755, "$CGIDIR/$file";
	print "done.\n";
}

foreach $file (@Utils) {
	print "Installing utilities in current directory...";
	open(SCRIPT, "$file")
		|| die "\nCouldn't read $file: $!\n";
	@script = <SCRIPT>;
	close SCRIPT;
	shift(@script);	# Toss current shbang line
	open(NEWSCRIPT, ">$file")
		|| die "\nCouldn't create $file: $!\n";
	print NEWSCRIPT "#!$Perl\n";
	for(@script) {
		print NEWSCRIPT $_;
	}
	close NEWSCRIPT;
	chmod 0755, $file;
	print "done.\n";
}

foreach $file (@Configs) {
	if (-f "$CGIDIR/$file") {
		$ans = &prompt("\n$CGIDIR/$file exists. Overwrite? ", 'n');
		next unless $ans =~ /^\s*y/i;
	}
	print "Copying $file to $CGIDIR/$file....";
	system('cp', $file, $CGIDIR)
		&& die "\nCouldn't create $CGIDIR/$file: $!\n";
	print "done.\n";
}

foreach $file (@Pages,@Gifs) {
	if (-f "$HTDOCDIR/$file") {
		$ans = &prompt("\n$HTDOCDIR/$file exists. Overwrite? ", 'n');
		next unless $ans =~ /^\s*y/i;
	}
	print "Copying $file to $HTDOCDIR/$file....";
	system('cp', $file, $HTDOCDIR)
		&& die "\nCouldn't create $HTDOCDIR/$file: $!\n";
	print "done.\n";
}

